/**
 * Klasse Fahrscheinautomat.
 * 
 * @author R. Punkenburg 
 * @version 2.2.2006
 */
public class Fahrscheinautomat
{
    private int fahrscheinWert;
    private boolean fahrscheinGewaehlt;
    private int summe;
    private Muenzpruefer muenzpruefer;
    private Drucker drucker;
    Muenzschacht muenzen5;
    Muenzschacht muenzen10;
    Muenzschacht muenzen20;
    Muenzschacht muenzen50;
    Muenzschacht muenzen100;
    Muenzschacht muenzen200;

    /**
     * Konstruktor fr Objekte der Klasse Fahrscheinautomat;
     * Es ist kein Fahrschein gewhlt;
     * Es ist keine Mnze eingeworfen worden.
     */
    public Fahrscheinautomat()
    {
        fahrscheinWert = 0;
        fahrscheinGewaehlt = false;
        summe = 0;
        muenzpruefer = new Muenzpruefer();
        drucker = new Drucker();
        muenzen5 = new Muenzschacht("5");
        muenzen10 = new Muenzschacht("10");
        muenzen20 = new Muenzschacht("20");
        muenzen50 = new Muenzschacht("50");
        muenzen100 = new Muenzschacht("100");
        muenzen200 = new Muenzschacht("200");
        
    }
    
    /**
     * Methode zum Verarbeiten der eingeworfenen Mnzen;
     * nur wenn ein Fahrschein gewhlt worden ist, werden Mnzeinwrfe akzeptiert;
     * wenn ausreichend Mnzen eingeworfen worden sind, wird der Vorgang abgearbeitet.
     * @param  wert  Wert der eingeworfenen Mnze
     */
    public void muenzEinwurf(int wert)
    {
        // prfen, ob Fahrschein gewhlt wurde
        if (!fahrscheinGewaehlt)
        {
            System.out.println("FSA: Bitte zunchst einen Fahrschein whlen!");
            return; // keine weitere Verarbeitung
        }

        // Mnze prfen, falls ungltig Methode abbrechen
        if (muenzpruefer.pruefe(wert) == 0)
        {
            System.out.println("FSA: Sie haben bisher insgesamt "+summe+" Cent eingeworfen.");
            return;
        }
        
        // nchste Mnze annehmen
        summe += wert;
        System.out.println("FSA: Sie haben eine Mnze von "+wert+" Cent eingeworfen.");
        System.out.println("FSA: Sie haben bisher insgesamt "+summe+" Cent eingeworfen.");
        
        // summe nicht ausreichend
        if (summe < fahrscheinWert)
        {
            System.out.println("FSA: Noch zu zahlen: "+(fahrscheinWert-summe));
            System.out.println("FSA: Bitte weitere Mnzen einwerfen.");
        }
        // summe ausreichend
        else
        {
            drucker.druckeFahrschein(fahrscheinWert);
            System.out.println("FSA: Sie erhalten "+(summe-fahrscheinWert)+" Cent zurck.");
            // Attribute zurcksetzen
            fahrscheinGewaehlt = false;
            fahrscheinWert = 0;
            summe = 0;
        }
    } // muenzEinwurf
    
    /**
     * Methode zum Auswhlen des Fahrscheins;
     * Typ = 1 : Fahrschein fr 145 Cent;
     * Typ = 2 : Fahrschein fr 185 Cent;
     * Typ = 3 : Fahrschein fr 220 Cent;
     * alle anderen Eingaben sind ungltig
     * @param  typ  Typ des Fahrscheins
     */
    public void waehleFahrschein(int typ)
    {
        if (drucker.leer())
        {
            System.out.println("FSA: Der Automat ist auer Betrieb!");
            return; // Methode abbrechen
        }
        
        if (fahrscheinGewaehlt)
        {
            System.out.println("FSA: Sie haben bereits einen Fahrschein gewhlt!");
            System.out.println("FSA: Weitere Mnzen einwerfen oder ABBRUCH whlen!");
            return;
        }
        
        if (typ == 1)
        {
            fahrscheinGewaehlt = true;
            fahrscheinWert = 145;
            System.out.println("FSA: Sie mchten einen Fahrschein fr 1,45 Euro. Bitte Mnzen einwerfen!");
        }
        else if (typ == 2)
        {
            fahrscheinGewaehlt = true;
            fahrscheinWert = 185;
            System.out.println("FSA: Sie mchten einen Fahrschein fr 1,85 Euro. Bitte Mnzen einwerfen!");
        }
        else if (typ == 3)
        {
            fahrscheinGewaehlt = true;
            fahrscheinWert = 220;
            System.out.println("FSA: Sie mchten einen Fahrschein fr 2,20 Euro. Bitte Mnzen einwerfen!");
        }
        else
        {
            fahrscheinGewaehlt = false;
            fahrscheinWert = 0;
            System.out.println("FSA: Ungltige Fahrscheinwahl!");
        }
    } // waehleFahrschein
    
    /**
     * Methode zum Abbrechen eines laufenden Vorgangs;
     * evtl. bereits eingeworfene Geld wird zurckgegeben;
     * kein Fahrschein ist gewhlt
     */
    public void abbrechen()
    {
        if (!fahrscheinGewaehlt) return; // nichts tun, weil nichts rckgngig zu machen ist
        System.out.println("FSA: Vorgang abgebrochen!");
        if (summe >0) 
        {
            System.out.println("FSA: Sie erhalten "+summe+" Cent zurck.");
        }
        fahrscheinGewaehlt = false;
        fahrscheinWert = 0;
        summe = 0;
    } // abbrechen
    
    
} // Fahrscheinautomat
